//
//  sharedLib.h
// 
// get information concerning loaded shared libraries given a pid
// 
#ifndef GETSHARED_H
#define GETSHARED_H

#include <string>
#include <vector>

class sharedLib
{
private:
    std::string m_name;
    unsigned    m_base;
public:
    sharedLib(const std::string& name, unsigned base) :
        m_name(name), m_base(base)
    {
    }
    const std::string& getName() const {return m_name;}
    unsigned getBase() const {return m_base;}
};

class sharedLibInfo
{
private:
    std::vector<sharedLib>  m_libs;
    std::string             m_procBase;
    unsigned long           m_dynamicBase;
    unsigned                m_dynamicSize;
public:
    sharedLibInfo(unsigned pid);
    unsigned numLibs() const;
    const sharedLib& getLib(unsigned index) const;
private:
    void processFileImage();
    void processRunningImage();
    std::string readString(unsigned addr, FILE* image);
};

#endif

